/*++

Copyright (c) Sydus.

Module:

    ISelectorImplementation.h

Authors:

    Sharvil Nanavati (sharvil) 2006-07-29

--*/

#pragma once

#include "base.h"

#include <set>

class ISelectable;
typedef std::set <ISelectable *> SelectedSet;

class ISelectorImplementation
{
	public:
		virtual void Alert() = 0;

		virtual int32 Select() = 0;
		virtual int32 Select(uint32 timeoutMillis) = 0;

		virtual const SelectedSet & AcceptSet() const = 0;
		virtual const SelectedSet & ReadSet() const = 0;
		virtual const SelectedSet & WriteSet() const = 0;

		virtual bool IsAlerted() const = 0;

		virtual ~ISelectorImplementation() {}

	private:
		friend class Selector;
		virtual bool Register(int32 fd, ISelectable & item) = 0;
		virtual void Unregister(int32 fd) = 0;
};
