/*++

Copyright (c) Sydus.

Module:

    Selector_Win32.h

Authors:

    Sharvil Nanavati (sharvil) 2006-07-29

--*/

#pragma once

#include "base.h"
#include "ISelectorImplementation.h"

class Selector_Win32 : public ISelectorImplementation
{
	public:
		Selector_Win32();
		~Selector_Win32();

		virtual void Alert();

		virtual int32 Select();
		virtual int32 Select(uint32 timeoutMillis);

		virtual const SelectedSet & AcceptSet() const;
		virtual const SelectedSet & ReadSet() const;
		virtual const SelectedSet & WriteSet() const;

		virtual bool IsAlerted() const;

	private:
		virtual bool Register(int32 fd, ISelectable & item);
		virtual void Unregister(int32 fd);

		typedef hash_map <SOCKET, ISelectable *> FdMap;

		FdMap iSelectables;
		SelectedSet iAcceptReady;
		SelectedSet iReadReady;
		SelectedSet iWriteReady;
		bool iIsAlerted;
		SOCKET iAlertRead;
		SOCKET iAlertWrite;
};
