/*++

Copyright (c) Sydus.

Module:

    IListenable.h

Authors:

    Sharvil Nanavati (sharvil) 2008-05-19

--*/

#pragma once

#include "base.h"

#include <list>

template <typename T>
class IListenable
{
	public:
		void AddListener(T & listener);
		void RemoveListener(const T & listener);

	protected:
		typedef std::list <T *> Listeners;

		IListenable();

		Listeners iListeners;
};

template <typename T>
IListenable <T>::IListenable()
{
}

template <typename T>
void IListenable <T>::AddListener(T & listener)
{
	iListeners.push_back(&listener);
}

template <typename T>
void IListenable <T>::RemoveListener(const T & listener)
{
	for(typename Listeners::iterator i = iListeners.begin(); i != iListeners.end(); ++i)
		if(*i == &listener)
		{
			iListeners.erase(i);
			break;
		}
}
