/*++

Copyright (c) Sydus.

Module:

	Module.h

Authors:

	Sharvil Nanavati (sharvil) 2006-03-25

--*/

#pragma once

#include "base.h"

//
// Note: the implementation of Module is extremely fragile. There is no compile-
// time check to guarantee that Module_Win32 and Module_Posix implement the same
// interface because the interface includes a templated method (and templated
// methods cannot be declared virtual).
//
// Any update must be checked against every platform to ensure a consistent
// interface and interface semantics.
//
#ifdef PLATFORM_WIN32

#	include "platform/nt/Module_Win32.h"
	typedef Module_Win32 Module;

#else

#	include "platform/posix/Module_Posix.h"
	typedef Module_Posix Module;

#endif
